package ru.amse.javadependencies.zhukova.data.dependencies.impl;

import ru.amse.javadependencies.zhukova.data.IClass;
import ru.amse.javadependencies.zhukova.data.dependencies.ITypeFeatureDependency;

/**
 * @author Anna R. Zhukova
 */
public class TypeFeatureDependency extends FeatureDependency implements ITypeFeatureDependency {
    public enum Type {
        EXTENDING_DEPENDENCY,
        FIELD_DEPENDENCY,
        METHOD_ARGUMENT_DEPENDENCY,
        METHOD_RETURN_TYPE_DEPENDENCY,
        LOCAL_VARIABLE_DEPENDENCY
    }

    private Type myType;

    public TypeFeatureDependency(IClass server, Type type) {
        super(server);
        myType = type;
    }

    public TypeFeatureDependency(IClass server) {
        super(server);
    }

    public void setType(Type type) {
        myType = type;
    }

    public Type getType() {
        return myType;
    }

    public String toString() {
        return "Type feature dependency: " + myType + "; " + super.toString();
    }
}
