/**
 * @author Anna R. Zhukova
 */
package ru.amse.javadependencies.zhukova.ui;

import ru.amse.javadependencies.zhukova.ui.menuactions.*;

import javax.swing.*;

/*package*/ class Menu {
    private static JMenuBar ourMenuBar;
    private static JMenu ourMenuFile;
    private static JMenu ourMenuHelp;
    private static JMenu ourMenuEdit;

    /*package*/
    static JMenuBar getMenuBar() {
        if (ourMenuBar == null) {
            ourMenuBar = new JMenuBar();
            ourMenuBar.add(getMenuFile());
            ourMenuBar.add(getMenuEdit());
        }
        return ourMenuBar;
    }

    private static JMenu getMenuFile() {
        if (ourMenuFile == null) {
            ourMenuFile = new JMenu("File");
            ourMenuFile.setMnemonic('f');
            ourMenuFile.add(Open.getInstance());
            ourMenuFile.add(OpenSavedFile.getInstance());
            ourMenuFile.add(SaveAs.getInstance());
            ourMenuFile.add(new JSeparator());
            ourMenuFile.add(Exit.getInstance());
        }
        return ourMenuFile;
    }

    private static JMenu getMenuHelp() {
        if (ourMenuHelp == null) {
            ourMenuHelp = new JMenu("Help");
            ourMenuHelp.setMnemonic('h');
        }
        return ourMenuHelp;
    }

    private static JMenu getMenuEdit() {
        if (ourMenuEdit == null) {
            ourMenuEdit = new JMenu("Edit");
            ourMenuEdit.setMnemonic('d');
            ourMenuEdit.add(Undo.getInstance());
            ourMenuEdit.add(Redo.getInstance());
        }
        return ourMenuEdit;
    }
}
