package ru.amse.javadependencies.zhukova.ui.commands;

import ru.amse.javadependencies.zhukova.model.IVertex;
import ru.amse.javadependencies.zhukova.model.IGraphModel;


public class MoveVertexCommand implements ICommand {
    private final IGraphModel myGraphModel;
    private final IVertex myVertex;
    private final int myDx;
    private final int myDy;

    public MoveVertexCommand(IGraphModel gr, IVertex classVertex, int x, int y){
        myGraphModel = gr;
        myVertex = classVertex;
        myDx = x;
        myDy = y;
    }

    public void doIt() {
        myGraphModel.moveVertex(myVertex, myDx, myDy);
    }

    public void undo() {
        myGraphModel.moveVertex(myVertex, -myDx, -myDy);
    }
}
