package ru.amse.javadependencies.zhukova.ui.graphpane.tools;

import ru.amse.javadependencies.zhukova.ui.commands.Composite;
import ru.amse.javadependencies.zhukova.ui.commands.MoveVertexCommand;
import ru.amse.javadependencies.zhukova.ui.graphpane.GraphPane;
import ru.amse.javadependencies.zhukova.ui.graphpane.IGraphPane;
import ru.amse.javadependencies.zhukova.model.IVertex;

import java.awt.event.MouseEvent;
import java.awt.*;
import java.util.Set;

/**
 * @author Anna R. Zhukova
 */
public class MovingTool extends Tool {
    private static Point ourVeryFrom;
    private static Point ourFrom;

    private static final MovingTool ourInstance = new MovingTool();

    private MovingTool() {
        super();
    }

    public static MovingTool getInstance(Point from) {
        ourFrom = from;
        ourVeryFrom = from;
        return ourInstance;
    }

    public void mouseDragged(MouseEvent e) {
        Point mouseLocation = e.getPoint();
        int dx = mouseLocation.x - ourFrom.x;
        int dy = mouseLocation.y - ourFrom.y;
        GraphPane graphPane = Tool.getGraphPane();
        Set<IVertex> vertices = graphPane.getSelectedVertices();
        for (IVertex v : vertices) {
            graphPane.getGraphModel().moveVertex(v, dx, dy);
        }
        ourFrom = mouseLocation;
        graphPane.repaint();
    }

    public void mouseReleased(MouseEvent e) {
        Composite c = new Composite();
        Point mouseLocation = e.getPoint();
        int dx = mouseLocation.x - ourVeryFrom.x;
        int dy = mouseLocation.y - ourVeryFrom.y;
        IGraphPane graphPane = Tool.getGraphPane();
        Set<IVertex> vertices = graphPane.getSelectedVertices();
        for (IVertex v : vertices) {
            c.addCommand(new MoveVertexCommand(graphPane.getGraphModel(), v, dx, dy));
        }
        Tool.getUndoManager().execute(c, true, false);
        graphPane.setTool(SelectingTool.getInstance());
    }

    public void paint(Graphics g) {           
    }
}
